--- old/exception_lists/copyright	Wed Apr 12 20:33:17 2023
+++ new/exception_lists/copyright	Wed Apr 12 20:33:17 2023
@@ -414,6 +414,7 @@
 usr/src/test/crypto-tests/tests/digest/data/README
 usr/src/test/libc-tests/tests/err/data/*
 usr/src/test/libmlrpc-tests/tests/netrlogon/krb5_pac_tests/krb5_pac.bin
+usr/src/test/os-tests/tests/xsave/data/*
 usr/src/test/util-tests/tests/dis/*/*.out
 usr/src/test/util-tests/tests/libsff/*.out
 usr/src/test/util-tests/tests/grep_xpg4/files/gout*
--- old/manifest	Wed Apr 12 20:33:17 2023
+++ new/manifest	Wed Apr 12 20:33:17 2023
@@ -4786,6 +4786,7 @@
 f usr/include/sys/stat_impl.h 0644 root bin
 f usr/include/sys/statfs.h 0644 root bin
 f usr/include/sys/statvfs.h 0644 root bin
+f usr/include/sys/stdalign.h 0644 root bin
 f usr/include/sys/stdbool.h 0644 root bin
 f usr/include/sys/stddef.h 0644 root bin
 f usr/include/sys/stdint.h 0644 root bin
@@ -12499,6 +12500,7 @@
 s usr/share/man/man2/getaudit_addr.2=getaudit.2
 f usr/share/man/man2/getauid.2 0444 root bin
 f usr/share/man/man2/getcontext.2 0444 root bin
+s usr/share/man/man2/getcontext_extd.2=getcontext.2
 f usr/share/man/man2/getdents.2 0444 root bin
 s usr/share/man/man2/getegid.2=getuid.2
 s usr/share/man/man2/geteuid.2=getuid.2
@@ -13394,6 +13396,7 @@
 f usr/share/man/man3c/madvise.3c 0444 root bin
 s usr/share/man/man3c/major.3c=makedev.3c
 f usr/share/man/man3c/makecontext.3c 0444 root bin
+s usr/share/man/man3c/makecontext_extd.3c=makecontext.3c
 f usr/share/man/man3c/makedev.3c 0444 root bin
 f usr/share/man/man3c/malloc.3c 0444 root bin
 f usr/share/man/man3c/mblen.3c 0444 root bin
@@ -13917,6 +13920,7 @@
 s usr/share/man/man3c/strxfrm_l.3c=strxfrm.3c
 f usr/share/man/man3c/swab.3c 0444 root bin
 s usr/share/man/man3c/swapcontext.3c=makecontext.3c
+s usr/share/man/man3c/swapcontext_extd.3c=makecontext.3c
 s usr/share/man/man3c/swprintf.3c=fwprintf.3c
 s usr/share/man/man3c/swscanf.3c=fwscanf.3c
 f usr/share/man/man3c/sync_instruction_memory.3c 0444 root bin
@@ -14014,6 +14018,8 @@
 f usr/share/man/man3c/u8_textprep_str.3c 0444 root bin
 f usr/share/man/man3c/u8_validate.3c 0444 root bin
 f usr/share/man/man3c/ualarm.3c 0444 root bin
+f usr/share/man/man3c/ucontext_alloc.3c 0444 root bin
+s usr/share/man/man3c/ucontext_free.3c=ucontext_alloc.3c
 f usr/share/man/man3c/uconv_u16tou32.3c 0444 root bin
 s usr/share/man/man3c/uconv_u16tou8.3c=uconv_u16tou32.3c
 s usr/share/man/man3c/uconv_u32tou16.3c=uconv_u16tou32.3c
@@ -17189,6 +17195,9 @@
 s usr/share/man/man3proc/Ldstop.3proc=Pstopstatus.3proc
 f usr/share/man/man3proc/Lfree.3proc 0444 root bin
 s usr/share/man/man3proc/Lgetareg.3proc=Pgetareg.3proc
+s usr/share/man/man3proc/Lgetfpregs.3proc=Plwp_getregs.3proc
+s usr/share/man/man3proc/Lgetregs.3proc=Plwp_getregs.3proc
+s usr/share/man/man3proc/Lgetxregs.3proc=Plwp_getregs.3proc
 f usr/share/man/man3proc/Lgrab.3proc 0444 root bin
 f usr/share/man/man3proc/Lgrab_error.3proc 0444 root bin
 s usr/share/man/man3proc/Lmain_stack.3proc=Plwp_stack.3proc
@@ -17195,7 +17204,10 @@
 f usr/share/man/man3proc/Lprochandle.3proc 0444 root bin
 f usr/share/man/man3proc/Lpsinfo.3proc 0444 root bin
 s usr/share/man/man3proc/Lputareg.3proc=Pgetareg.3proc
+s usr/share/man/man3proc/Lsetfpregs.3proc=Plwp_getregs.3proc
+s usr/share/man/man3proc/Lsetregs.3proc=Plwp_getregs.3proc
 s usr/share/man/man3proc/Lsetrun.3proc=Psetrun.3proc
+s usr/share/man/man3proc/Lsetxregs.3proc=Plwp_getregs.3proc
 s usr/share/man/man3proc/Lstack.3proc=Plwp_stack.3proc
 f usr/share/man/man3proc/Lstate.3proc 0444 root bin
 f usr/share/man/man3proc/Lstatus.3proc 0444 root bin
@@ -17250,6 +17262,7 @@
 f usr/share/man/man3proc/Plookup_by_addr.3proc 0444 root bin
 s usr/share/man/man3proc/Plookup_by_name.3proc=Plookup_by_addr.3proc
 s usr/share/man/man3proc/Plwp_alt_stack.3proc=Plwp_stack.3proc
+s usr/share/man/man3proc/Plwp_freexregs.3proc=Plwp_getxregs.3proc
 f usr/share/man/man3proc/Plwp_getasrs.3proc 0444 root bin
 s usr/share/man/man3proc/Plwp_getfpregs.3proc=Plwp_getregs.3proc
 f usr/share/man/man3proc/Plwp_getgwindows.3proc 0444 root bin
--- old/usr/src/cmd/mdb/common/mdb/mdb_proc.c	Wed Apr 12 20:33:18 2023
+++ new/usr/src/cmd/mdb/common/mdb/mdb_proc.c	Wed Apr 12 20:33:18 2023
@@ -26,7 +26,7 @@
 /*
  * Copyright 2018 Joyent, Inc.
  * Copyright (c) 2014 by Delphix. All rights reserved.
- * Copyright 2020 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 /*
@@ -4639,31 +4639,6 @@
 			else if (rd_flags & MDB_TGT_R_8L)
 				r &= 0xffULL;
 
-#if defined(__sparc) && defined(_ILP32)
-			/*
-			 * If we are debugging on 32-bit SPARC, the globals and
-			 * outs can have 32 upper bits stored in the xregs.
-			 */
-			int is_g = (rd_num == R_G0 ||
-			    rd_num >= R_G1 && rd_num <= R_G7);
-			int is_o = (rd_num >= R_O0 && rd_num <= R_O7);
-			prxregset_t xrs;
-
-			if ((is_g || is_o) && PTL_GETXREGS(t, tid, &xrs) == 0 &&
-			    xrs.pr_type == XR_TYPE_V8P) {
-				if (is_g) {
-					xrs.pr_un.pr_v8p.pr_xg[rd_num -
-					    R_G0 + XR_G0] = (uint32_t)(r >> 32);
-				} else if (is_o) {
-					xrs.pr_un.pr_v8p.pr_xo[rd_num -
-					    R_O0 + XR_O0] = (uint32_t)(r >> 32);
-				}
-
-				if (PTL_SETXREGS(t, tid, &xrs) == -1)
-					return (-1);
-			}
-#endif	/* __sparc && _ILP32 */
-
 			if (PTL_GETREGS(t, tid, grs) == 0) {
 				grs[rd_num] = (prgreg_t)r;
 				return (PTL_SETREGS(t, tid, grs));
@@ -4837,33 +4812,38 @@
 	return (set_errno(EMDB_NOPROC));
 }
 
-#ifdef	__sparc
 
 /*ARGSUSED*/
 static int
-pt_lwp_getxregs(mdb_tgt_t *t, void *tap, mdb_tgt_tid_t tid, prxregset_t *xregs)
+pt_lwp_getxregs(mdb_tgt_t *t, void *tap, mdb_tgt_tid_t tid, prxregset_t **xregs,
+    size_t *sizep)
 {
 	if (t->t_pshandle != NULL) {
 		return (ptl_err(Plwp_getxregs(t->t_pshandle,
-		    (lwpid_t)tid, xregs)));
+		    (lwpid_t)tid, xregs, sizep)));
 	}
 	return (set_errno(EMDB_NOPROC));
 }
 
-/*ARGSUSED*/
+static void
+pt_lwp_freexregs(mdb_tgt_t *t, void *tap, prxregset_t *xregs, size_t size)
+{
+	if (t->t_pshandle != NULL) {
+		Plwp_freexregs(t->t_pshandle, xregs, size);
+	}
+}
+
 static int
 pt_lwp_setxregs(mdb_tgt_t *t, void *tap, mdb_tgt_tid_t tid,
-    const prxregset_t *xregs)
+    const prxregset_t *xregs, size_t len)
 {
 	if (t->t_pshandle != NULL) {
 		return (ptl_err(Plwp_setxregs(t->t_pshandle,
-		    (lwpid_t)tid, xregs)));
+		    (lwpid_t)tid, xregs, len)));
 	}
 	return (set_errno(EMDB_NOPROC));
 }
 
-#endif	/* __sparc */
-
 /*ARGSUSED*/
 static int
 pt_lwp_getfpregs(mdb_tgt_t *t, void *tap, mdb_tgt_tid_t tid,
@@ -4889,18 +4869,17 @@
 }
 
 static const pt_ptl_ops_t proc_lwp_ops = {
-	(int (*)())(uintptr_t)mdb_tgt_nop,
-	(void (*)())(uintptr_t)mdb_tgt_nop,
-	pt_lwp_tid,
-	pt_lwp_iter,
-	pt_lwp_getregs,
-	pt_lwp_setregs,
-#ifdef __sparc
-	pt_lwp_getxregs,
-	pt_lwp_setxregs,
-#endif
-	pt_lwp_getfpregs,
-	pt_lwp_setfpregs
+	.ptl_ctor = (int (*)())(uintptr_t)mdb_tgt_nop,
+	.ptl_dtor = (void (*)())(uintptr_t)mdb_tgt_nop,
+	.ptl_tid = pt_lwp_tid,
+	.ptl_iter = pt_lwp_iter,
+	.ptl_getregs = pt_lwp_getregs,
+	.ptl_setregs = pt_lwp_setregs,
+	.ptl_getxregs = pt_lwp_getxregs,
+	.ptl_freexregs = pt_lwp_freexregs,
+	.ptl_setxregs = pt_lwp_setxregs,
+	.ptl_getfpregs = pt_lwp_getfpregs,
+	.ptl_setfpregs = pt_lwp_setfpregs
 };
 
 static int
@@ -5024,15 +5003,16 @@
 	return (0);
 }
 
-#ifdef __sparc
-
 static int
-pt_tdb_getxregs(mdb_tgt_t *t, void *tap, mdb_tgt_tid_t tid, prxregset_t *xregs)
+pt_tdb_getxregs(mdb_tgt_t *t, void *tap, mdb_tgt_tid_t tid, prxregset_t **xregs,
+    size_t *sizep)
 {
 	pt_data_t *pt = t->t_data;
 
 	td_thrhandle_t th;
 	td_err_e err;
+	int xregsize;
+	prxregset_t *pxr;
 
 	if (t->t_pshandle == NULL)
 		return (set_errno(EMDB_NOPROC));
@@ -5040,16 +5020,36 @@
 	if ((err = pt->p_tdb_ops->td_ta_map_id2thr(tap, tid, &th)) != TD_OK)
 		return (set_errno(tdb_to_errno(err)));
 
-	err = pt->p_tdb_ops->td_thr_getxregs(&th, xregs);
-	if (err != TD_OK && err != TD_PARTIALREG)
+	if ((err = pt->p_tdb_ops->td_thr_getxregsize(&th, &xregsize)) != TD_OK)
 		return (set_errno(tdb_to_errno(err)));
 
+	if (xregsize == 0) {
+		return (set_errno(ENODATA));
+	}
+
+	pxr = mdb_alloc(xregsize, UM_SLEEP);
+
+	err = pt->p_tdb_ops->td_thr_getxregs(&th, pxr);
+	if (err != TD_OK && err != TD_PARTIALREG) {
+		mdb_free(pxr, xregsize);
+		return (set_errno(tdb_to_errno(err)));
+	}
+
+	*xregs = pxr;
+	*sizep = xregsize;
 	return (0);
 }
 
+static void
+pt_tdb_freexregs(mdb_tgt_t *t __unused, void *tap __unused, prxregset_t *pxr,
+    size_t size)
+{
+	mdb_free(pxr, size);
+}
+
 static int
 pt_tdb_setxregs(mdb_tgt_t *t, void *tap, mdb_tgt_tid_t tid,
-    const prxregset_t *xregs)
+    const prxregset_t *xregs, size_t len __unused)
 {
 	pt_data_t *pt = t->t_data;
 
@@ -5069,8 +5069,6 @@
 	return (0);
 }
 
-#endif	/* __sparc */
-
 static int
 pt_tdb_getfpregs(mdb_tgt_t *t, void *tap, mdb_tgt_tid_t tid,
     prfpregset_t *fpregs)
@@ -5116,18 +5114,17 @@
 }
 
 static const pt_ptl_ops_t proc_tdb_ops = {
-	pt_tdb_ctor,
-	pt_tdb_dtor,
-	pt_tdb_tid,
-	pt_tdb_iter,
-	pt_tdb_getregs,
-	pt_tdb_setregs,
-#ifdef __sparc
-	pt_tdb_getxregs,
-	pt_tdb_setxregs,
-#endif
-	pt_tdb_getfpregs,
-	pt_tdb_setfpregs
+	.ptl_ctor = pt_tdb_ctor,
+	.ptl_dtor = pt_tdb_dtor,
+	.ptl_tid = pt_tdb_tid,
+	.ptl_iter = pt_tdb_iter,
+	.ptl_getregs = pt_tdb_getregs,
+	.ptl_setregs = pt_tdb_setregs,
+	.ptl_getxregs = pt_tdb_getxregs,
+	.ptl_freexregs = pt_tdb_freexregs,
+	.ptl_setxregs = pt_tdb_setxregs,
+	.ptl_getfpregs = pt_tdb_getfpregs,
+	.ptl_setfpregs = pt_tdb_setfpregs
 };
 
 static ssize_t
--- old/usr/src/cmd/mdb/common/mdb/mdb_proc.h	Wed Apr 12 20:33:19 2023
+++ new/usr/src/cmd/mdb/common/mdb/mdb_proc.h	Wed Apr 12 20:33:19 2023
@@ -63,12 +63,11 @@
 	int (*ptl_iter)(mdb_tgt_t *, void *, mdb_addrvec_t *);
 	int (*ptl_getregs)(mdb_tgt_t *, void *, mdb_tgt_tid_t, prgregset_t);
 	int (*ptl_setregs)(mdb_tgt_t *, void *, mdb_tgt_tid_t, prgregset_t);
-#ifdef	__sparc
 	int (*ptl_getxregs)(mdb_tgt_t *, void *, mdb_tgt_tid_t,
-	    prxregset_t *);
+	    prxregset_t **, size_t *);
+	void (*ptl_freexregs)(mdb_tgt_t *, void *, prxregset_t *, size_t);
 	int (*ptl_setxregs)(mdb_tgt_t *, void *, mdb_tgt_tid_t,
-	    const prxregset_t *);
-#endif
+	    const prxregset_t *, size_t);
 	int (*ptl_getfpregs)(mdb_tgt_t *, void *, mdb_tgt_tid_t,
 	    prfpregset_t *);
 	int (*ptl_setfpregs)(mdb_tgt_t *, void *, mdb_tgt_tid_t,
@@ -98,18 +97,18 @@
 	(((pt_data_t *)((t)->t_data))->p_ptl_ops->ptl_setregs((t), \
 	((pt_data_t *)((t)->t_data))->p_ptl_hdl, (tid), (gregs)))
 
-#ifdef	__sparc
-
-#define	PTL_GETXREGS(t, tid, xregs) \
+#define	PTL_GETXREGS(t, tid, xregs, size) \
 	(((pt_data_t *)((t)->t_data))->p_ptl_ops->ptl_getxregs((t), \
-	((pt_data_t *)((t)->t_data))->p_ptl_hdl, (tid), (xregs)))
+	((pt_data_t *)((t)->t_data))->p_ptl_hdl, (tid), (xregs), (size)))
 
-#define	PTL_SETXREGS(t, tid, xregs) \
+#define	PTL_FREEXREGS(t, xregs, size) \
+	(((pt_data_t *)((t)->t_data))->p_ptl_ops->ptl_freexregs((t), \
+	((pt_data_t *)((t)->t_data))->p_ptl_hdl, (xregs), (size)))
+
+#define	PTL_SETXREGS(t, tid, xregs, size) \
 	(((pt_data_t *)((t)->t_data))->p_ptl_ops->ptl_setxregs((t), \
-	((pt_data_t *)((t)->t_data))->p_ptl_hdl, (tid), (xregs)))
+	((pt_data_t *)((t)->t_data))->p_ptl_hdl, (tid), (xregs), (size)))
 
-#endif	/* __sparc */
-
 #define	PTL_GETFPREGS(t, tid, fpregs) \
 	(((pt_data_t *)((t)->t_data))->p_ptl_ops->ptl_getfpregs((t), \
 	((pt_data_t *)((t)->t_data))->p_ptl_hdl, (tid), (fpregs)))
--- old/usr/src/cmd/mdb/common/mdb/mdb_tdb.c	Wed Apr 12 20:33:19 2023
+++ new/usr/src/cmd/mdb/common/mdb/mdb_tdb.c	Wed Apr 12 20:33:19 2023
@@ -183,7 +183,11 @@
 	if (t->tdb_ops.td_thr_tlsbase == NULL)
 		t->tdb_ops.td_thr_tlsbase = (td_err_e (*)())tdb_notsup;
 
-#ifdef __sparc
+	t->tdb_ops.td_thr_getxregsize = (td_err_e (*)())
+	    dlsym(hdl, "td_thr_getxregsize");
+	if (t->tdb_ops.td_thr_getxregsize == NULL)
+		t->tdb_ops.td_thr_getxregsize = (td_err_e (*)())tdb_notsup;
+
 	t->tdb_ops.td_thr_getxregs = (td_err_e (*)())
 	    dlsym(hdl, "td_thr_getxregs");
 	if (t->tdb_ops.td_thr_getxregs == NULL)
@@ -193,7 +197,6 @@
 	    dlsym(hdl, "td_thr_setxregs");
 	if (t->tdb_ops.td_thr_setxregs == NULL)
 		t->tdb_ops.td_thr_setxregs = (td_err_e (*)())tdb_notsup;
-#endif	/* __sparc */
 
 	return (&t->tdb_ops);
 }
--- old/usr/src/cmd/mdb/common/mdb/mdb_tdb.h	Wed Apr 12 20:33:19 2023
+++ new/usr/src/cmd/mdb/common/mdb/mdb_tdb.h	Wed Apr 12 20:33:19 2023
@@ -53,10 +53,9 @@
 	td_err_e (*td_thr_setfpregs)(const td_thrhandle_t *,
 	    const prfpregset_t *);
 	td_err_e (*td_thr_tlsbase)(const td_thrhandle_t *, ulong_t, psaddr_t *);
-#ifdef __sparc
+	td_err_e (*td_thr_getxregsize)(const td_thrhandle_t *, int *);
 	td_err_e (*td_thr_getxregs)(const td_thrhandle_t *, void *);
 	td_err_e (*td_thr_setxregs)(const td_thrhandle_t *, const void *);
-#endif
 } mdb_tdb_ops_t;
 
 typedef struct mdb_tdb_lib {
--- old/usr/src/cmd/mdb/intel/amd64/mdb/Makefile	Wed Apr 12 20:33:19 2023
+++ new/usr/src/cmd/mdb/intel/amd64/mdb/Makefile	Wed Apr 12 20:33:19 2023
@@ -31,6 +31,7 @@
 	mdb_ia32util.c \
 	mdb_x86util.c \
 	mdb_bhyve.c \
+	proc_x86util.c \
 	proc_amd64dep.c
 
 %.o: %.c
--- old/usr/src/cmd/mdb/intel/ia32/mdb/Makefile	Wed Apr 12 20:33:19 2023
+++ new/usr/src/cmd/mdb/intel/ia32/mdb/Makefile	Wed Apr 12 20:33:19 2023
@@ -22,11 +22,11 @@
 # Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-#ident	"%Z%%M%	%I%	%E% SMI"
 
 SRCS =	kvm_ia32dep.c \
 	kvm_isadep.c \
 	mdb_ia32util.c \
+	proc_x86util.c \
 	proc_ia32dep.c
 
 %.o: ../../mdb/%.c
--- old/usr/src/cmd/mdb/intel/mdb/proc_amd64dep.c	Wed Apr 12 20:33:19 2023
+++ new/usr/src/cmd/mdb/intel/mdb/proc_amd64dep.c	Wed Apr 12 20:33:19 2023
@@ -26,10 +26,11 @@
 /*
  * Copyright (c) 2018, Joyent, Inc.
  * Copyright 2019 Doma Gergő Mihály <doma.gergo.mihaly@gmail.com>
+ * Copyright 2023 Oxide Computer Company
  */
 
 /*
- * User Process Target Intel 32-bit component
+ * User Process Target Intel 64-bit component
  *
  * This file provides the ISA-dependent portion of the user process target.
  * For more details on the implementation refer to mdb_proc.c.
@@ -40,6 +41,7 @@
 #include <mdb/mdb_err.h>
 #include <mdb/mdb_isautil.h>
 #include <mdb/mdb_amd64util.h>
+#include <mdb/proc_x86util.h>
 #include <mdb/mdb.h>
 
 #include <sys/ucontext.h>
@@ -47,6 +49,7 @@
 #include <libproc.h>
 #include <sys/fp.h>
 #include <ieeefp.h>
+#include <sys/sysmacros.h>
 
 #include <stddef.h>
 
@@ -279,242 +282,15 @@
 	return (set_errno(ENOTSUP));
 }
 
-static const char *
-fpcw2str(uint32_t cw, char *buf, size_t nbytes)
-{
-	char *end = buf + nbytes;
-	char *p = buf;
-
-	buf[0] = '\0';
-
-	/*
-	 * Decode all exception masks in the x87 FPU Control Word.
-	 *
-	 * See here:
-	 * Intel® 64 and IA-32 Architectures Software Developer’s Manual,
-	 * Volume 1: Basic Architecture, 8.1.5 x87 FPU Control Word
-	 */
-	if (cw & FPIM)	/* Invalid operation mask. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|IM");
-	if (cw & FPDM)	/* Denormalized operand mask. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|DM");
-	if (cw & FPZM)	/* Zero divide mask. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|ZM");
-	if (cw & FPOM)	/* Overflow mask. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|OM");
-	if (cw & FPUM)	/* Underflow mask. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|UM");
-	if (cw & FPPM)	/* Precision mask. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|PM");
-
-	/*
-	 * Decode precision control options.
-	 */
-	switch (cw & FPPC) {
-	case FPSIG24:
-		/* 24-bit significand, single precision. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|SIG24");
-		break;
-	case FPSIG53:
-		/* 53-bit significand, double precision. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|SIG53");
-		break;
-	case FPSIG64:
-		/* 64-bit significand, double extended precision. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|SIG64");
-		break;
-	default:
-		/*
-		 * Should never happen.
-		 * Value 0x00000100 is 'Reserved'.
-		 */
-		break;
-	}
-
-	/*
-	 * Decode rounding control options.
-	 */
-	switch (cw & FPRC) {
-	case FPRTN:
-		/* Round to nearest, or to even if equidistant. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|RTN");
-		break;
-	case FPRD:
-		/* Round down. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|RD");
-		break;
-	case FPRU:
-		/* Round up. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|RU");
-		break;
-	case FPCHOP:
-		/* Truncate. */
-		p += mdb_snprintf(p, (size_t)(end - p), "|RTZ");
-		break;
-	default:
-		/*
-		 * This is a two-bit field.
-		 * No other options left.
-		 */
-		break;
-	}
-
-	/*
-	 * Decode infinity control options.
-	 *
-	 * This field has been retained for compatibility with
-	 * the 287 and earlier co-processors.
-	 * In the more modern FPUs, this bit is disregarded and
-	 * both -infinity and +infinity are respected.
-	 * Comment source: SIMPLY FPU by Raymond Filiatreault
-	 */
-	switch (cw & FPIC) {
-	case FPP:
-		/*
-		 * Projective infinity.
-		 * Both -infinity and +infinity are treated as
-		 * unsigned infinity.
-		 */
-		p += mdb_snprintf(p, (size_t)(end - p), "|P");
-		break;
-	case FPA:
-		/*
-		 * Affine infinity.
-		 * Respects both -infinity and +infinity.
-		 */
-		p += mdb_snprintf(p, (size_t)(end - p), "|A");
-		break;
-	default:
-		/*
-		 * This is a one-bit field.
-		 * No other options left.
-		 */
-		break;
-	}
-
-	if (cw & WFPB17)
-		p += mdb_snprintf(p, (size_t)(end - p), "|WFPB17");
-	if (cw & WFPB24)
-		p += mdb_snprintf(p, (size_t)(end - p), "|WFPB24");
-
-	if (buf[0] == '|')
-		return (buf + 1);
-
-	return ("0");
-}
-
-static const char *
-fpsw2str(uint32_t cw, char *buf, size_t nbytes)
-{
-	char *end = buf + nbytes;
-	char *p = buf;
-
-	buf[0] = '\0';
-
-	/*
-	 * Decode all masks in the 80387 status word.
-	 */
-	if (cw & FPS_IE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|IE");
-	if (cw & FPS_DE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|DE");
-	if (cw & FPS_ZE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|ZE");
-	if (cw & FPS_OE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|OE");
-	if (cw & FPS_UE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|UE");
-	if (cw & FPS_PE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|PE");
-	if (cw & FPS_SF)
-		p += mdb_snprintf(p, (size_t)(end - p), "|SF");
-	if (cw & FPS_ES)
-		p += mdb_snprintf(p, (size_t)(end - p), "|ES");
-	if (cw & FPS_C0)
-		p += mdb_snprintf(p, (size_t)(end - p), "|C0");
-	if (cw & FPS_C1)
-		p += mdb_snprintf(p, (size_t)(end - p), "|C1");
-	if (cw & FPS_C2)
-		p += mdb_snprintf(p, (size_t)(end - p), "|C2");
-	if (cw & FPS_C3)
-		p += mdb_snprintf(p, (size_t)(end - p), "|C3");
-	if (cw & FPS_B)
-		p += mdb_snprintf(p, (size_t)(end - p), "|B");
-
-	if (buf[0] == '|')
-		return (buf + 1);
-
-	return ("0");
-}
-
-static const char *
-fpmxcsr2str(uint32_t mxcsr, char *buf, size_t nbytes)
-{
-	char *end = buf + nbytes;
-	char *p = buf;
-
-	buf[0] = '\0';
-
-	/*
-	 * Decode the MXCSR word
-	 */
-	if (mxcsr & SSE_IE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|IE");
-	if (mxcsr & SSE_DE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|DE");
-	if (mxcsr & SSE_ZE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|ZE");
-	if (mxcsr & SSE_OE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|OE");
-	if (mxcsr & SSE_UE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|UE");
-	if (mxcsr & SSE_PE)
-		p += mdb_snprintf(p, (size_t)(end - p), "|PE");
-
-	if (mxcsr & SSE_DAZ)
-		p += mdb_snprintf(p, (size_t)(end - p), "|DAZ");
-
-	if (mxcsr & SSE_IM)
-		p += mdb_snprintf(p, (size_t)(end - p), "|IM");
-	if (mxcsr & SSE_DM)
-		p += mdb_snprintf(p, (size_t)(end - p), "|DM");
-	if (mxcsr & SSE_ZM)
-		p += mdb_snprintf(p, (size_t)(end - p), "|ZM");
-	if (mxcsr & SSE_OM)
-		p += mdb_snprintf(p, (size_t)(end - p), "|OM");
-	if (mxcsr & SSE_UM)
-		p += mdb_snprintf(p, (size_t)(end - p), "|UM");
-	if (mxcsr & SSE_PM)
-		p += mdb_snprintf(p, (size_t)(end - p), "|PM");
-
-	if ((mxcsr & SSE_RC) == (SSE_RD|SSE_RU))
-		p += mdb_snprintf(p, (size_t)(end - p), "|RTZ");
-	else if (mxcsr & SSE_RD)
-		p += mdb_snprintf(p, (size_t)(end - p), "|RD");
-	else if (mxcsr & SSE_RU)
-		p += mdb_snprintf(p, (size_t)(end - p), "|RU");
-	else
-		p += mdb_snprintf(p, (size_t)(end - p), "|RTN");
-
-	if (mxcsr & SSE_FZ)
-		p += mdb_snprintf(p, (size_t)(end - p), "|FZ");
-
-	if (buf[0] == '|')
-		return (buf + 1);
-	return ("0");
-}
-
-/*ARGSUSED*/
 int
 pt_fpregs(uintptr_t addr, uint_t flags, int argc, const mdb_arg_t *argv)
 {
-	mdb_tgt_t *t = mdb.m_target;
-	mdb_tgt_tid_t tid;
+	int ret;
 	prfpregset_t fprs;
 	struct _fpchip_state fps;
 	char buf[256];
 	uint_t top;
-	int i;
+	size_t i;
 
 	/*
 	 * Union for overlaying _fpreg structure on to quad-precision
@@ -526,37 +302,16 @@
 	} fpru;
 
 	/*
-	 * Array of strings corresponding to FPU tag word values (see
-	 * section 7.3.6 of the Intel Programmer's Reference Manual).
+	 * We use common code between 32-bit and 64-bit x86 to capture and print
+	 * the extended vector state. The remaining classic 387 state is
+	 * finicky and different enough that it is left to be dealt with on its
+	 * own.
 	 */
-	const char *tag_strings[] = { "valid", "zero", "special", "empty" };
+	if ((ret = x86_pt_fpregs_common(addr, flags, argc, &fprs)) != DCMD_OK)
+		return (ret);
 
-	if (argc != 0)
-		return (DCMD_USAGE);
-
-	if (t->t_pshandle == NULL || Pstate(t->t_pshandle) == PS_UNDEAD) {
-		mdb_warn("no process active\n");
-		return (DCMD_ERR);
-	}
-
-	if (Pstate(t->t_pshandle) == PS_LOST) {
-		mdb_warn("debugger has lost control of process\n");
-		return (DCMD_ERR);
-	}
-
-	if (flags & DCMD_ADDRSPEC)
-		tid = (mdb_tgt_tid_t)addr;
-	else
-		tid = PTL_TID(t);
-
-	mdb_printf("AMD64 (80486 chip with SSE)\n");
-
-	if (PTL_GETFPREGS(t, tid, &fprs) != 0) {
-		mdb_warn("failed to get floating point registers");
-		return (DCMD_ERR);
-	}
-
 	bcopy(&fprs.fp_reg_set.fpchip_state, &fps, sizeof (fps));
+	mdb_printf("387 and FP Control State\n");
 
 	fps.status &= 0xffff;	/* saved status word is really 16 bits */
 
@@ -574,7 +329,7 @@
 	mdb_printf("rip    0x%x\n", fps.rip);
 	mdb_printf("rdp    0x%x\n\n", fps.rdp);
 
-	for (i = 0; i < 8; i++) {
+	for (i = 0; i < ARRAY_SIZE(fps.st); i++) {
 		/*
 		 * Recall that we need to use the current TOP-of-stack value to
 		 * associate the _st[] index back to a physical register number,
@@ -619,19 +374,11 @@
 		    i, fpru.reg.exponent,
 		    fpru.reg.significand[3], fpru.reg.significand[2],
 		    fpru.reg.significand[1], fpru.reg.significand[0],
-		    fpru.ld, tag_strings[tag_value]);
+		    fpru.ld, fptag2str(tag_value));
 	}
 
-	mdb_printf("\nmxcsr  0x%04x (%s)\n", fps.mxcsr,
-	    fpmxcsr2str(fps.mxcsr, buf, sizeof (buf)));
-	mdb_printf("xcp    0x%04x (%s)\n\n", fps.xstatus,
-	    fpmxcsr2str(fps.xstatus, buf, sizeof (buf)));
+	x86_pt_fpregs_sse_ctl(fps.mxcsr, fps.xstatus, buf, sizeof (buf));
 
-	for (i = 0; i < 8; i++)
-		mdb_printf("%%xmm%d  0x%08x%08x%08x%08x\n", i,
-		    fps.xmm[i]._l[3], fps.xmm[i]._l[2],
-		    fps.xmm[i]._l[1], fps.xmm[i]._l[0]);
-
 	return (DCMD_OK);
 }
 
